using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace WinformsInteropDemo
{
    [Serializable]
    public class Contact
    {
        private String m_FirstName;
        private String m_LastName;
        private String m_Extension;
        private String m_ImagePath;
        private String m_ColHeader;


        public Contact()
        {
        }

        public Contact(string p_ColHeader, string p_FirstName, string p_LastName, string p_Extension, String imagePath)
        {
            FirstName = p_FirstName;
            LastName = p_LastName;
            Extension = p_Extension;
            ImagePath = imagePath;
            ColHeader = p_ColHeader;
        }
        public string ColHeader
        {
            get { return m_ColHeader; }
            set { m_ColHeader = value; }
        }
        public String ImagePath
        {
            get { return m_ImagePath; }
            set { m_ImagePath = value; }
        }
        public string Extension
        {
            get { return m_Extension; }
            set { m_Extension = value; }
        }

        public override string ToString()
        {
            return String.Format("Contact Info: \n First Name: {0}\n Last Name: {1}\n Extension: {2}\n Image: {3}", FirstName, LastName, Extension, ImagePath);
        }

        public String LastName
        {
            get { return m_LastName; }
            set { m_LastName = value; }
        }

        public String FirstName
        {
            get { return m_FirstName; }
            set { m_FirstName = value; }
        }
    }

    [Serializable]
    public class ContactTest
    {
        private static List<Contact> m_Contacts;
        public static List<Contact> Contacts
        {
            get { return m_Contacts; }
        }

        static ContactTest()
        {

            m_Contacts = new List<Contact>();
            String tmpImage=@"Images\Sunset.jpg";
            String tmpImage1=@"Images\Winter.jpg";
            m_Contacts.Add(new Contact("1", "Joe", "Schmoe", "147", tmpImage));
            m_Contacts.Add(new Contact("2", "John", "Doe", "154", tmpImage1));
            m_Contacts.Add(new Contact("3", "Albert", "Hacker", "113", tmpImage));
            m_Contacts.Add(new Contact("4", "Mike", "Brown", "112", tmpImage1));

        }
    }
}
